/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.24 from the
 * contents of Dbx.xs. Do not edit this file, edit Dbx.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Dbx.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "libdbx/libdbx.h"
#include "libdbx/timeconv.h"

#include "const-c.inc"

/* This is not gentlemen-like:
 * But under Win32: (PerlIO*) == (FILE*) */
#ifdef _WIN32
# define PerlIO_exportFILE(f,fl) ((FILE*)(f))
#endif

#define glob_ref(sv) (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVGV)
#define sv_to_file(sv) (PerlIO_exportFILE(IoIFP(sv_2io(sv)), NULL))

#define WARN        fprintf(stderr, "%i\n", __LINE__)
#define WARNi(arg)  fprintf(stderr, "%i: %i\n", __LINE__, arg)

/* We're not thread-safe anyway. :-)
 * But we cannot do without for garbage-collecting. */
int IN_DBX_DESTROY = 0;

struct dbx_email {
    SV          *dbx;		/* Mail::Transport::Dbx object */
    DBXEMAIL    *email;
    char        *header;	/* just the header */
    char        *body;		/* just the body */
};

struct dbx_folder {
    SV          *dbx;		/* Mail::Transport::Dbx object */
    DBXFOLDER   *folder;  
    AV		*fullpath;
};

struct dbx_box {
    DBX		*dbx;
    SV		**subfolders;	/* Mail::Transport::Dbx::Folder objects */
    /* originally used for fullpath() but now obsolete */
/*  int		*indexid;
    int		indexsize;
*/
};

typedef struct dbx_email    DBX_EMAIL;
typedef struct dbx_folder   DBX_FOLDER;
typedef struct dbx_box	    DBX_BOX;

typedef struct {
    char *name;
    int pid;
} folder_info;

/* copied from perl/pp_sys.c */
static char *dayname[] = {
    "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};
static char *monname[] = {
    "Jan", "Feb", "Mar", "Apr", "May", "Jun", 
    "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

char * errstr () {
        switch(dbx_errno) {
            /* messages copied from libdbx.h */
            case DBX_NOERROR:
                return "No error";
            case DBX_BADFILE:
                return "Dbx file operation failed (open or close)";
            case DBX_ITEMCOUNT:
                return "Reading of Item Count from dbx file failed";
            case DBX_INDEX_READ:
                return "Reading of Index Pointer from dbx file failed";
            case DBX_INDEX_UNDERREAD:
                return 
                "Number of indexes read from dbx file is less than expected";
            case DBX_INDEX_OVERREAD:
                return
                "Request was made for index reference greater than exists";
            case DBX_INDEXCOUNT:
                return "Index out of range";
            case DBX_DATA_READ:
                return "Reading of data from dbx file failed";
            case DBX_NEWS_ITEM:
                return "Item is a news item not an email";
            default:
                break;
        }
        return "Odd...an unknown error occured";
}

void split_mail (pTHX_ DBX_EMAIL *self) {

    if (self->header)
        return;
    
    else {
        char *ptr;
        int count = 0;

        /* email data not yet loaded */
        if (!self->email->email) 
            (void) dbx_get_email_body(((DBX_BOX*)SvIV((SV*)SvRV(self->dbx)))->dbx, 
                                      self->email);
        
        ptr = self->email->email;
        
        if (dbx_errno == DBX_DATA_READ) {
            /* A message can be there and not be there at the same time!
             * Explanation:
             * newsgroup items can be downloaded partially in OutlookX
             * In this case dbx_get_email_body() will store nothing in
             * self->email->email in which case header and body would be 
             * empty. then dbx_errno is set to DBX_DATA_READ which we
             * don't consider an error here */
            dbx_errno = DBX_NOERROR;
            return;
        }
        if (dbx_errno == DBX_BADFILE)
            croak("dbx panic: file stream disappeared");

        while (ptr+4) {
            /* two newlines is separator */
            if (strnEQ(ptr, "\r\n\r\n", 4)) {
                break;
            }
            count++; ptr++;
        }
        /* +3: +"\r\n\0" */
        self->header = (char*) safemalloc(sizeof(char) * (count+3));
        self->body = (char*) 
            safemalloc(sizeof(char) * (strlen(self->email->email) - count));
        
        strncpy(self->header, self->email->email, count+2);
        self->header[count+2] = '\0';
        /* +4 to ommit the two newlines ("\r\n\r\n") */
        strcpy(self->body, ptr+4);
    }
}
    
int datify (pTHX_ FILETIME *wintime, int method) {
    dSP;
    time_t time = FileTimeToUnixTime(wintime, NULL);
    struct tm *tstruct;
    (void) POPs; /* removing pending object which is in ST(0) */

    if (method == 0)  /* localtime */
        tstruct = localtime(&time);
    else              /* gmtime */
        tstruct = gmtime(&time);
    
    if (GIMME == G_ARRAY) {
        EXTEND(SP, 9);
        PUSHs(sv_2mortal(newSViv(tstruct->tm_sec)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_min)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_hour)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_mday)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_mon)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_year)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_wday)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_yday)));
        PUSHs(sv_2mortal(newSViv(tstruct->tm_isdst)));
        PUTBACK;
        return 9;
    } else {
        SV *str = newSVpvf("%s %s %2d %02d:%02d:%02d %d",
                  dayname[tstruct->tm_wday],
                  monname[tstruct->tm_mon],
                  tstruct->tm_mday,
                  tstruct->tm_hour,
                  tstruct->tm_min,
                  tstruct->tm_sec,
                  tstruct->tm_year + 1900);                   
        EXTEND(SP, 1);
        PUSHs(sv_2mortal(str));
        PUTBACK;
        return 1;
    }
}

int get_folder (SV *o, int index, SV **sv) {
    DBX_FOLDER *folder;
    DBX_BOX *dbx = (DBX_BOX*)SvIV(SvRV(o));
    DBXFOLDER *ret = (DBXFOLDER*)dbx_get(dbx->dbx, index, 0);
    New(0, folder, 1, DBX_FOLDER);
    folder->dbx = o;
    folder->folder = ret;
    folder->fullpath = Nullav;
    *sv = sv_setref_pv(newSV(0), "Mail::Transport::Dbx::Folder", (void*)folder);
    SvREFCNT_inc(o);
    return ret->id;
}
	
#line 209 "Dbx.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 351 "Dbx.c"

/* INCLUDE:  Including 'const-xs.inc' from 'Dbx.xs' */


XS_EUPXS(XS_Mail__Transport__Dbx_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 376 "Dbx.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Mail::Transport::Dbx macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Mail::Transport::Dbx macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Mail::Transport::Dbx macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 454 "Dbx.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'Dbx.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Mail__Transport__Dbx_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, dbx");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	SV *	dbx = ST(1)
;
#line 209 "Dbx.xs"
        STRLEN len;
#line 477 "Dbx.c"
	DBX_BOX *	RETVAL;
#line 211 "Dbx.xs"
	New(0, RETVAL, 1, DBX_BOX);
	RETVAL->subfolders = NULL;
        if (glob_ref(dbx) && !errno)
            RETVAL->dbx = dbx_open_stream(sv_to_file(dbx));
        else
            RETVAL->dbx = dbx_open(SvPV(dbx, len));

        if (!RETVAL->dbx)
            croak("%s", errstr());

#line 490 "Dbx.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, index");
    {
	SV *	self = ST(0)
;
	int	index = (int)SvIV(ST(1))
;
#line 229 "Dbx.xs"
        void *ret_type;
	DBX_BOX *dbx;
#line 512 "Dbx.c"
#line 232 "Dbx.xs"
        dbx = (DBX_BOX*)SvIV((SV*)SvRV(self));
        ret_type = dbx_get(dbx->dbx, index, 0);
        if (!ret_type)
            XSRETURN_UNDEF;

	/* objects derived from a DBX struct keep a pointer
	 * to this struct because it is needed later; so
	 * we need to increment the DBX's refcount */
	SvREFCNT_inc(self); 
	if (dbx->dbx->type == DBX_TYPE_EMAIL) {
	    DBX_EMAIL *ret;
	    New(0, ret, 1, DBX_EMAIL);
	    ST(0) = sv_newmortal();
	    ret->dbx = self;
	    ret->email = (DBXEMAIL*) ret_type;
	    ret->header = NULL;
	    ret->body = NULL;
	    sv_setref_pv(ST(0), "Mail::Transport::Dbx::Email", (void*)ret);
	    XSRETURN(1);
	}
	else if (dbx->dbx->type == DBX_TYPE_FOLDER) {
	    if (!dbx->subfolders) {
		int id;
		SV *sv;
		Newz(0, dbx->subfolders, dbx->dbx->indexCount, SV*);
		/* New(0, dbx->indexid, dbx->indexsize = dbx->dbx->indexCount, int); */
		id = get_folder(self, index, &dbx->subfolders[index]);
		/*
		if (id >= dbx->indexsize) {
		    dbx->indexsize = id+1;
		    Renew(dbx->indexid, dbx->indexsize, int);
		}
		dbx->indexid[id] = index;
		*/
		ST(0) = sv_mortalcopy(dbx->subfolders[index]);
	    } else 
		ST(0) = sv_mortalcopy(dbx->subfolders[index]);
	    //SvREFCNT_inc(self);
	    XSRETURN(1);
	}
#line 554 "Dbx.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_error)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 276 "Dbx.xs"
        RETVAL = dbx_errno;
#line 570 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx_errstr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_errstr)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	RETVAL;
	dXSTARG;
#line 283 "Dbx.xs"
        RETVAL = errstr();
#line 587 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx_msgcount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_msgcount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_BOX *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_BOX *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::msgcount() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 291 "Dbx.xs"
        RETVAL = self->dbx->indexCount;
#line 614 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx_emails); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_emails)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
#line 299 "Dbx.xs"
        DBX_BOX *self;
#line 634 "Dbx.c"
#line 301 "Dbx.xs"
        self = (DBX_BOX*)SvIV((SV*)SvRV(object));
        if (GIMME_V == G_SCALAR) {
            if (self->dbx->type == DBX_TYPE_EMAIL) 
                XSRETURN_YES;
            else
                XSRETURN_NO;
        }
        if (GIMME_V == G_ARRAY) {
            int i;
            if (self->dbx->type != DBX_TYPE_EMAIL || self->dbx->indexCount == 0)
                XSRETURN_EMPTY;
            for (i = 0; i < self->dbx->indexCount; i++) {
                SV *o = sv_newmortal();
                void *item = dbx_get(self->dbx, i, 0);
                DBX_EMAIL *ret = (DBX_EMAIL*) safemalloc(sizeof(DBX_EMAIL));
                ret->dbx = object;
                ret->email = (DBXEMAIL*) item;
                ret->header = NULL;
                ret->body = NULL;
                SvREFCNT_inc(object);
                o = sv_setref_pv(o, "Mail::Transport::Dbx::Email", (void*)ret);
                XPUSHs(o);
            }
            XSRETURN(i);
        }
#line 661 "Dbx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mail__Transport__Dbx_subfolders); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_subfolders)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
#line 331 "Dbx.xs"
        DBX_BOX *self;
#line 681 "Dbx.c"
#line 333 "Dbx.xs"
        self = (DBX_BOX*)SvIV((SV*)SvRV(object));

        if (GIMME_V == G_SCALAR) { 
            if (self->dbx->type == DBX_TYPE_FOLDER) 
                XSRETURN_YES;
            else
                XSRETURN_NO;
        }

        if (GIMME_V == G_ARRAY) {
            int i;
            if (self->dbx->type != DBX_TYPE_FOLDER || self->dbx->indexCount == 0)
                XSRETURN_EMPTY;
	    if (self->subfolders) {
		EXTEND(SP, self->dbx->indexCount);
		for (i = 0; i < self->dbx->indexCount; i++) {
		    if (!self->subfolders[i]) {
			int id = get_folder(object, i, &self->subfolders[i]);
			/*
			if (id >= self->indexsize) {
			    self->indexsize = id+1;
			    Renew(self->indexid, self->indexsize, int);
			}
			self->indexid[id] = i;
			*/
		    }
		    ST(i) = sv_mortalcopy(self->subfolders[i]);
		    SvREFCNT_inc(object);
		}
		XSRETURN(self->dbx->indexCount);
	    } else {
		EXTEND(SP, self->dbx->indexCount);
		New(0, self->subfolders, self->dbx->indexCount, SV*);
		/* New(0, self->indexid, self->indexsize = self->dbx->indexCount, int); */
		for (i = 0; i < self->dbx->indexCount; i++) {
		    int id = get_folder(object, i, &self->subfolders[i]);
		    /*
		    if (id >= self->indexsize) {
			self->indexsize = id+1;
			Renew(self->indexid, self->indexsize, int);
		    }
		    self->indexid[id] = i;
		    */
		    PUSHs(sv_mortalcopy(self->subfolders[i]));
		    SvREFCNT_inc(object);
		}
		XSRETURN(self->dbx->indexCount);
	    }
        }
#line 732 "Dbx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mail__Transport__Dbx_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_BOX *	self;
#line 387 "Dbx.xs"
	register int i;
#line 749 "Dbx.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_BOX *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 389 "Dbx.xs"
	IN_DBX_DESTROY = 1;
	if (self->subfolders) {
	    for (i = 0; i < self->dbx->indexCount; i++) {
		SvREFCNT_dec(self->subfolders[i]);
	    }
	    Safefree(self->subfolders);
	    /* Safefree(self->indexid); */
	    self->subfolders = NULL;
	}
        dbx_close(self->dbx);
	IN_DBX_DESTROY = 0;
#line 770 "Dbx.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_psubject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_psubject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::psubject() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 407 "Dbx.xs"
        RETVAL = self->email->psubject;
#line 796 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_subject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_subject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::subject() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 415 "Dbx.xs"
        RETVAL = self->email->subject;
#line 823 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_as_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::as_string() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 423 "Dbx.xs"
        if (!(RETVAL = self->email->email)) {
            (void) dbx_get_email_body(((DBX_BOX*)SvIV((SV*)SvRV(self->dbx)))->dbx, 
                                      self->email);
            if (dbx_errno == DBX_DATA_READ)
                /* see comment in split_mail() */        
                XSRETURN_UNDEF;
            RETVAL = self->email->email;
        }
#line 857 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_header)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::header() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 438 "Dbx.xs"
        split_mail(aTHX_ self);
        if (!(RETVAL = self->header))
            XSRETURN_UNDEF;
#line 886 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_body); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_body)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::body() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 448 "Dbx.xs"
        split_mail(aTHX_ self);
        if (!(RETVAL = self->body))
            XSRETURN_UNDEF;
#line 915 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_msgid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_msgid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::msgid() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 458 "Dbx.xs"
        RETVAL = self->email->messageid;
#line 942 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_parents_ids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_parents_ids)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::parents_ids() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 466 "Dbx.xs"
        RETVAL = self->email->parent_message_ids;
#line 969 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_sender_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_sender_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::sender_name() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 474 "Dbx.xs"
        RETVAL = self->email->sender_name;
#line 996 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_sender_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_sender_address)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::sender_address() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 482 "Dbx.xs"
        RETVAL = self->email->sender_address;
#line 1023 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_recip_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_recip_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::recip_name() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 490 "Dbx.xs"
        RETVAL = self->email->recip_name;
#line 1050 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_recip_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_recip_address)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::recip_address() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 498 "Dbx.xs"
        RETVAL = self->email->recip_address;
#line 1077 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_oe_account_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_oe_account_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::oe_account_name() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 506 "Dbx.xs"
        RETVAL = self->email->oe_account_name;
#line 1104 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_oe_account_num); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_oe_account_num)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::oe_account_num() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 514 "Dbx.xs"
        RETVAL = self->email->oe_account_num;
#line 1131 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_fetched_server); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_fetched_server)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::fetched_server() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 522 "Dbx.xs"
        RETVAL = self->email->fetched_server;
#line 1158 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_rcvd_localtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_rcvd_localtime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	DBX_EMAIL *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::rcvd_localtime() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 530 "Dbx.xs"
        XSRETURN(datify(aTHX_ &(self->email->date), 0));
#line 1185 "Dbx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_rcvd_gmtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_rcvd_gmtime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	DBX_EMAIL *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::rcvd_gmtime() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 536 "Dbx.xs"
        XSRETURN(datify(aTHX_ &(self->email->date), 1));
#line 1212 "Dbx.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_date_received); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_date_received)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	DBX_EMAIL *	self;
#line 542 "Dbx.xs"
        char *format = "%a %b %e %H:%M:%S %Y";
        STRLEN n_a;
        size_t max_len = 25;
        time_t time;
        struct tm *tstruct;
        char *string;
#line 1234 "Dbx.c"
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::date_received() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 549 "Dbx.xs"
        if (items > 1)
            format = (char *) SvPV(ST(1), n_a);
        if (items > 2)
            max_len = (int) SvIV(ST(2));   

        time = FileTimeToUnixTime(&(self->email->date), NULL);

        if (items > 3 && SvTRUE(ST(3)))
            tstruct = gmtime(&time);
        else 
            tstruct = localtime(&time);

        string = (char*) safemalloc(sizeof(char) * max_len);
        strftime(string, max_len, format, tstruct);
        RETVAL = string;
#line 1261 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_seen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_seen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::is_seen() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 571 "Dbx.xs"
        RETVAL = (self->email->flag & DBX_EMAIL_FLAG_ISSEEN) > 0 ? 1 : 0;
#line 1288 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_email); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_email)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::is_email() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 579 "Dbx.xs"
        RETVAL = 1;
#line 1315 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_folder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_is_folder)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::is_folder() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 587 "Dbx.xs"
        RETVAL = 0;
#line 1342 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Email_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Email_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_EMAIL *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_EMAIL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Email::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 595 "Dbx.xs"
        if (self->header)
            safefree(self->header);
        if (self->body)
            safefree(self->body);

        dbx_free(((DBX_BOX*)SvIV((SV*)SvRV(self->dbx)))->dbx, self->email);
        SvREFCNT_dec(self->dbx);
        self->dbx = NULL;
        safefree(self);
#line 1375 "Dbx.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_num); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_num)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::num() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 612 "Dbx.xs"
        RETVAL = self->folder->num;
#line 1401 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::type() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 620 "Dbx.xs"
        RETVAL = self->folder->type;
#line 1428 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::name() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 628 "Dbx.xs"
        RETVAL = self->folder->name;
#line 1455 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_file)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::file() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 636 "Dbx.xs"
        RETVAL = self->folder->fname;
#line 1482 "Dbx.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::id() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 644 "Dbx.xs"
        RETVAL = self->folder->id;
#line 1509 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_parent_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_parent_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::parent_id() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 652 "Dbx.xs"
        RETVAL = self->folder->parentid;
#line 1536 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_is_email); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_is_email)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::is_email() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 660 "Dbx.xs"
        RETVAL = 0;
#line 1563 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_is_folder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_is_folder)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::is_folder() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 668 "Dbx.xs"
        RETVAL = 1;
#line 1590 "Dbx.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_dbx); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_dbx)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
#line 676 "Dbx.xs"
        char *CLASS = "Mail::Transport::Dbx"; /* used in typemap */
#line 1607 "Dbx.c"
	DBX_BOX *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::dbx() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 678 "Dbx.xs"
        if (!self->folder->fname)
            XSRETURN_UNDEF;
	New(0, RETVAL, 1, DBX_BOX);
	RETVAL->subfolders = NULL;
        RETVAL->dbx = dbx_open(self->folder->fname);
#line 1623 "Dbx.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mail__Transport__Dbx__Folder__dbx); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder__dbx)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
	SV *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::_dbx() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 690 "Dbx.xs"
	RETVAL = self->dbx;
	SvREFCNT_inc(RETVAL);
#line 1651 "Dbx.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Mail__Transport__Dbx__Folder_fullpath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder_fullpath)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
#line 702 "Dbx.xs"
	register int i;
	DBX_BOX *dbx;
	int parent;
	SV *sv;
	AV *av;
	int numret;
#line 1677 "Dbx.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::fullpath() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 709 "Dbx.xs"
	av = self->fullpath;
	if (av)
	    goto done;    

	av = newAV();

	dbx = (DBX_BOX*)SvIV(SvRV(self->dbx));

	if (!dbx->subfolders) {
	    Newz(0, dbx->subfolders, dbx->dbx->indexCount, SV*);
	    New(0, dbx->indexid, dbx->indexsize = dbx->dbx->indexCount, int);
	}

	for (i = 0; i < dbx->dbx->indexCount; i++) {
	    if (!dbx->subfolders[i]) {
		int id = get_folder(self->dbx, i, &(dbx->subfolders[i]));
		if (id >= dbx->indexsize) {
		    dbx->indexsize = id+1;
		    Renew(dbx->indexid, dbx->indexsize, int);
		}
		dbx->indexid[id] = i;
	    }
	}

	parent = self->folder->parentid;

	while (1) {
	    SV *sv = dbx->subfolders[dbx->indexid[parent]];
	    DBX_FOLDER *f = (DBX_FOLDER*)SvIV(SvRV(sv));
	    av_push(av, newSVpv(f->folder->name, 0));
	    if (parent == 0)
		break;
	    parent = f->folder->parentid;
	}

    done:
	numret = av_len(av) + 1;
	for (i = 0; i < numret; i++)
	    ST(numret-i-1) = sv_mortalcopy(*av_fetch(av, i, FALSE));
	ST(numret) = sv_2mortal(newSVpv(self->folder->name, 0));
	XSRETURN(numret+1);
#line 1728 "Dbx.c"
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Mail__Transport__Dbx__Folder__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__Folder__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	DBX_FOLDER *	self;
#line 757 "Dbx.xs"
	DBX_BOX *dbx;
	SV *sv;
#line 1746 "Dbx.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (DBX_FOLDER *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Mail::Transport::Dbx::Folder::_DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 760 "Dbx.xs"
	/* we have a sort of circular destruction problem here:
	 * M::T::Dbx::DESTROY triggers M:T::DBX::Folder::DESTROY
	 * which itself decrements DBX_BOX' refcount so
	 * M::T::Dbx::DESTROY is called again which then calls
	 * M::T::DBX::Folder::DESTROY and so on. */
	if (IN_DBX_DESTROY)
	    XSRETURN_UNDEF;

	/* I don't know why I have to do this: 
	 * without this check it will segfault under certain circumstances 
	 * on threaded perls. */
	if ((sv = (SV*)SvRV(self->dbx))) {
	    dbx = (DBX_BOX*)SvIV(sv);
	    dbx_free(dbx->dbx, self->folder);
	}

        SvREFCNT_dec(self->dbx);
	if (self->fullpath) {
	    SV *sv;
	    while ((sv = av_pop(self->fullpath)) != &PL_sv_undef)
		SvREFCNT_dec(sv);
	    SvREFCNT_dec(self->fullpath);
	}
        self->dbx = NULL;
        Safefree(self);
#line 1781 "Dbx.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mail__Transport__Dbx__folder_info_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mail__Transport__Dbx__folder_info_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 792 "Dbx.xs"
    {
	folder_info *finfo = (folder_info*)SvIV(SvRV(sv));
	Safefree(finfo->name);
	Safefree(finfo);
    }
#line 1802 "Dbx.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Mail__Transport__Dbx); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Mail__Transport__Dbx)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Mail::Transport::Dbx::constant", XS_Mail__Transport__Dbx_constant, file);
        newXS("Mail::Transport::Dbx::new", XS_Mail__Transport__Dbx_new, file);
        newXS("Mail::Transport::Dbx::get", XS_Mail__Transport__Dbx_get, file);
        newXS("Mail::Transport::Dbx::error", XS_Mail__Transport__Dbx_error, file);
        newXS("Mail::Transport::Dbx::errstr", XS_Mail__Transport__Dbx_errstr, file);
        newXS("Mail::Transport::Dbx::msgcount", XS_Mail__Transport__Dbx_msgcount, file);
        newXS("Mail::Transport::Dbx::emails", XS_Mail__Transport__Dbx_emails, file);
        newXS("Mail::Transport::Dbx::subfolders", XS_Mail__Transport__Dbx_subfolders, file);
        newXS("Mail::Transport::Dbx::DESTROY", XS_Mail__Transport__Dbx_DESTROY, file);
        newXS("Mail::Transport::Dbx::Email::psubject", XS_Mail__Transport__Dbx__Email_psubject, file);
        newXS("Mail::Transport::Dbx::Email::subject", XS_Mail__Transport__Dbx__Email_subject, file);
        newXS("Mail::Transport::Dbx::Email::as_string", XS_Mail__Transport__Dbx__Email_as_string, file);
        newXS("Mail::Transport::Dbx::Email::header", XS_Mail__Transport__Dbx__Email_header, file);
        newXS("Mail::Transport::Dbx::Email::body", XS_Mail__Transport__Dbx__Email_body, file);
        newXS("Mail::Transport::Dbx::Email::msgid", XS_Mail__Transport__Dbx__Email_msgid, file);
        newXS("Mail::Transport::Dbx::Email::parents_ids", XS_Mail__Transport__Dbx__Email_parents_ids, file);
        newXS("Mail::Transport::Dbx::Email::sender_name", XS_Mail__Transport__Dbx__Email_sender_name, file);
        newXS("Mail::Transport::Dbx::Email::sender_address", XS_Mail__Transport__Dbx__Email_sender_address, file);
        newXS("Mail::Transport::Dbx::Email::recip_name", XS_Mail__Transport__Dbx__Email_recip_name, file);
        newXS("Mail::Transport::Dbx::Email::recip_address", XS_Mail__Transport__Dbx__Email_recip_address, file);
        newXS("Mail::Transport::Dbx::Email::oe_account_name", XS_Mail__Transport__Dbx__Email_oe_account_name, file);
        newXS("Mail::Transport::Dbx::Email::oe_account_num", XS_Mail__Transport__Dbx__Email_oe_account_num, file);
        newXS("Mail::Transport::Dbx::Email::fetched_server", XS_Mail__Transport__Dbx__Email_fetched_server, file);
        newXS("Mail::Transport::Dbx::Email::rcvd_localtime", XS_Mail__Transport__Dbx__Email_rcvd_localtime, file);
        newXS("Mail::Transport::Dbx::Email::rcvd_gmtime", XS_Mail__Transport__Dbx__Email_rcvd_gmtime, file);
        newXS("Mail::Transport::Dbx::Email::date_received", XS_Mail__Transport__Dbx__Email_date_received, file);
        newXS("Mail::Transport::Dbx::Email::is_seen", XS_Mail__Transport__Dbx__Email_is_seen, file);
        newXS("Mail::Transport::Dbx::Email::is_email", XS_Mail__Transport__Dbx__Email_is_email, file);
        newXS("Mail::Transport::Dbx::Email::is_folder", XS_Mail__Transport__Dbx__Email_is_folder, file);
        newXS("Mail::Transport::Dbx::Email::DESTROY", XS_Mail__Transport__Dbx__Email_DESTROY, file);
        newXS("Mail::Transport::Dbx::Folder::num", XS_Mail__Transport__Dbx__Folder_num, file);
        newXS("Mail::Transport::Dbx::Folder::type", XS_Mail__Transport__Dbx__Folder_type, file);
        newXS("Mail::Transport::Dbx::Folder::name", XS_Mail__Transport__Dbx__Folder_name, file);
        newXS("Mail::Transport::Dbx::Folder::file", XS_Mail__Transport__Dbx__Folder_file, file);
        newXS("Mail::Transport::Dbx::Folder::id", XS_Mail__Transport__Dbx__Folder_id, file);
        newXS("Mail::Transport::Dbx::Folder::parent_id", XS_Mail__Transport__Dbx__Folder_parent_id, file);
        newXS("Mail::Transport::Dbx::Folder::is_email", XS_Mail__Transport__Dbx__Folder_is_email, file);
        newXS("Mail::Transport::Dbx::Folder::is_folder", XS_Mail__Transport__Dbx__Folder_is_folder, file);
        newXS("Mail::Transport::Dbx::Folder::dbx", XS_Mail__Transport__Dbx__Folder_dbx, file);
        newXS("Mail::Transport::Dbx::Folder::_dbx", XS_Mail__Transport__Dbx__Folder__dbx, file);
#if XSubPPtmpAAAA
        newXS("Mail::Transport::Dbx::Folder::fullpath", XS_Mail__Transport__Dbx__Folder_fullpath, file);
#endif
        newXS("Mail::Transport::Dbx::Folder::_DESTROY", XS_Mail__Transport__Dbx__Folder__DESTROY, file);
        newXS("Mail::Transport::Dbx::folder_info::DESTROY", XS_Mail__Transport__Dbx__folder_info_DESTROY, file);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 1877 "Dbx.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

